#include <fstream.h>
#include <qapp.h>
#include <qslider.h>
#include <qlayout.h> 

#define NUM_RTCTRL 12

class RTctrl : public QObject {

  Q_OBJECT
public:

  RTctrl(unsigned char channel,ofstream* rtf,int initialvalue=0) :
    QObject(),channel(channel),rtf(rtf) {set(initialvalue);};
public slots:

void set(int value) {*rtf << channel << (unsigned char)value << flush;};

private:

  unsigned char channel;
  ofstream* rtf;
};

#include "gui.moc.cpp"

int main(int argc,char **argv) {

  QApplication app(argc,argv);
  QWidget w;
  QHBoxLayout layout(&w,10);

  char* fifo=(argc==2)?argv[1]:"/dev/rtf0";
  ofstream rtf(fifo);

  for(int i=0;i<NUM_RTCTRL;i++) {

    QSlider* slider=new QSlider(0,255,1,255,QSlider::Vertical,&w);
    slider->setTickmarks(QSlider::Right);
    slider->setTickInterval(16);
    layout.addWidget(slider);

    RTctrl* rtctrl=new RTctrl(i,&rtf,255);
    rtctrl->connect(slider,SIGNAL(valueChanged(int)),SLOT(set(int)));
  };

  app.setMainWidget(&w);
  w.resize(480,200);
  w.show();
  return app.exec();
};
















