#include <rtl.h>
#include <rtl_fifo.h>
#include <time.h>
#include <pthread.h>
#include <asm/io.h>


int port=0x61;
int fifo=0;
int period=125000;
int resolution=255;
int oversamp=2;


pthread_t thread;
volatile int t=0;


void *thread_code(void *arg) {
  hrtime_t now=gethrtime();

  period/=oversamp;

  while(1) {
    int i;
    char data;
    int t0,t1,t;
   
    if(rtf_get(fifo,&data,1)>0) {
      t=data;
      if(t>0) t=255-t;
      else t+=128;
      t=(t*period)/(resolution);
    }
    else {
      t=0;
    };
    
    t0=period-t;
    t1=t;

    for(i=0;i<oversamp;i++) {
      if(t0) {
	char temp = inb(port);            
	temp &= 0xfc;
	outb(temp,port);
	pthread_make_periodic_np(pthread_self(),now+=t0,period);
	pthread_wait_np();
      };
      
      if(t1) {
	char temp = inb(port);
	temp |= 3;
	outb(temp,port);
	pthread_make_periodic_np(pthread_self(),now+=t1,period);
	pthread_wait_np();
      };
    };
  };
};


MODULE_PARM(port,"i");
MODULE_PARM(fifo,"i");
MODULE_PARM(period,"i");
MODULE_PARM(resolution,"i");
MODULE_PARM(oversamp,"i");


int init_module(void) {
  pthread_attr_t attr;
  struct sched_param sched_param;

  rtf_create(fifo,4000);

  pthread_attr_init(&attr);
  pthread_attr_setcpu_np(&attr,0);
  sched_param.sched_priority=1;
  pthread_attr_setschedparam(&attr,&sched_param);
  pthread_create(&thread,&attr,thread_code,0);

  return 0;
};


void cleanup_module(void) {
  pthread_delete_np(thread);
  rtf_destroy(fifo);
};
